package com.hellokoding.jpa.model;

import javax.persistence.*;

@Entity
public class BookPublisher {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private int id;

    @ManyToOne()
    @JoinColumn(name = "book_id")
    private Book book;

    @ManyToOne()
    @JoinColumn(name = "publisher_id")
    private Publisher publisher;

    public BookPublisher() {
    }

    public BookPublisher(Book book, Publisher publisher) {
        this.book = book;
        this.publisher = publisher;
    }

    public Book getBook() {
        return book;
    }

    public void setBook(Book book) {
        this.book = book;
    }

    public Publisher getPublisher() {
        return publisher;
    }

    public void setPublisher(Publisher publisher) {
        this.publisher = publisher;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        BookPublisher that = (BookPublisher) o;

        if (!getBook().equals(that.getBook())) return false;
        return getPublisher().equals(that.getPublisher());

    }

    @Override
    public int hashCode() {
        int result = getBook().hashCode();
        result = 31 * result + getPublisher().hashCode();
        return result;
    }

    @Override
    public String toString() {
        return this.book.getName() + "-" + this.publisher.getName();
    }
}
