package com.hellokoding.jpa.model;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Entity
public class Publisher {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private int id;
    private String name;

//    @ManyToMany(mappedBy = "publishers")//,fetch = FetchType.EAGER)
//    private List<Book> books = new ArrayList<>();

    @OneToMany(mappedBy = "publisher", fetch = FetchType.LAZY)
    private List<BookPublisher> bookPublisherList = new ArrayList<>();

    public Publisher() {

    }

    public Publisher(String name) {
        this.name = name;
    }


    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<BookPublisher> getBookPublisherList() {
        return bookPublisherList;
    }

    public void setBookPublisherList(List<BookPublisher> bookPublisherList) {
        this.bookPublisherList = bookPublisherList;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Publisher publisher = (Publisher) o;

        if (getId() != publisher.getId()) return false;
        return getName().equals(publisher.getName());

    }

    @Override
    public int hashCode() {
        int result = getId();
        result = 31 * result + getName().hashCode();
        return result;
    }

    @Override
    public String toString() {
        return this.getName();
    }
}
